import defaults from './src/defaults';
import { config } from './src/types';
import request from './src/request';

class Scathach {
  private config: config
  private useragent: string
  private apikey: string
  static default: typeof Scathach;


  constructor(config?: config) {
    this.config = config || defaults;
    this.useragent = this.config?.useragent ? `${defaults.useragent} ${this.config.useragent}` : defaults.useragent;
    this.apikey = this.config?.apikey ? this.config.apikey : '';
  }


  /**
   * Get a random whores from fgo
   * @returns Unfiltered scathach.redsplit.org/v5/fgo Response
   */
  async getFgo() {
    try {
      const res = await request({
        category: 'fgo',
        useragent: this.useragent,
        apikey: this.apikey
      });
      return res;
    } catch (error) {
      console.error(error);
    }
  }

  /**
   * Get a random slut from genshin
   * @returns Unfiltered scathach.redsplit.org/v5/genshin Response
   */
  async getGenshin() {
    try {
      const res = await request({
        category: 'genshin',
        useragent: this.useragent,
        apikey: this.apikey
      });
      return res;
    } catch (error) {
      console.error(error);
    }
  }

  /**
  * Get a random slut from azur lane
  * @returns Unfiltered scathach.redsplit.org/v5/azur_lane Response
  */
  async getAzur() {
    try {
      const res = await request({
        category: 'azur',
        useragent: this.useragent,
        apikey: this.apikey
      });
      return res;
    } catch (error) {
      console.error(error);
    }
  }

  /**
   * Get a random wholesome waifu
   * @returns Unfiltered scathach.redsplit.org/v5/waifu Response
   */
  async getWaifu() {
    try {
      const res = await request({
        category: 'waifu',
        useragent: this.useragent,
        apikey: this.apikey
      });
      return res;
    } catch (error) {
      console.error(error);
    }
  }

  /**
   * Get a random sex porn gif
   * @returns Unfiltered scathach.redsplit.org/v5/sex Response
   */
  async getSex() {
    try {
      const res = await request({
        category: 'sex',
        useragent: this.useragent,
        apikey: this.apikey
      });
      return res;
    } catch (error) {
      console.error(error);
    }
  }

  /**
   * Get a reaction from servant fate
   * @param img The reaction to get
   * @returns Unfiltered servant.gitlab.com/d0g/servant/-/raw/master/_constant/ Response
   * @example
   * getReaction("smug")
   * getReaction("cry")
   * getReaction("pout")
   * getReaction("bonk")
   * @returns the random reaction from scathach bot
   */
  async reaction(img: string) {
    try {
      const res = await request({
        category: 'reaction',
        img,
        useragent: this.useragent
      });
      return res;
    } catch (error) {
      console.error(error);
    }
  }

  /**
   * Request random posts from gelbooru
   * @param tags The Tags your want to use for your Search
   * @param limit the amount of posts you want back
   * @param block the block you want to search in
   * @param page the page you want to search on
   * @returns A data that represents the proxied gelbooru response from scathach bot
   */
  async gelbooru(tags: string | string[], limit?: number, page?: number, block?: string | string[]) {
    try {
      const res = await request({
        category: 'gelbooru',
        limit, tags, page, block,
        useragent: this.useragent

      });
      return res;
    } catch (error) {
      console.error(error);
    }
  }


}

Scathach.default = Scathach;
export = Scathach;